/* A Bison parser, made by GNU Bison 2.3.  */

/* Skeleton implementation for Bison's Yacc-like parsers in C

   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004, 2005, 2006
   Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 51 Franklin Street, Fifth Floor,
   Boston, MA 02110-1301, USA.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.3"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Using locations.  */
#define YYLSP_NEEDED 0



/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     TOK_ID = 258,
     TOK_SEP = 259,
     TOK_OPEN = 260,
     TOK_CLOSE = 261,
     TOK_MODE = 262,
     TOK_END_OF_RULE = 263,
     TOK_EQUALS = 264,
     TOK_ARROW = 265,
     TOK_ADD_ASSIGN = 266,
     TOK_SET_VAR = 267,
     TOK_BOOL_VAR = 268,
     TOK_VALUE = 269,
     TOK_IF = 270,
     TOK_ELSE = 271,
     TOK_NOT = 272,
     TOK_DEFINED = 273,
     TOK_CHANGE_PROFILE = 274,
     TOK_NETWORK = 275,
     TOK_HAT = 276,
     TOK_UNSAFE = 277,
     TOK_COLON = 278,
     TOK_LINK = 279,
     TOK_OWNER = 280,
     TOK_CAPABILITY = 281,
     TOK_FLAGS = 282,
     TOK_FLAG_OPENPAREN = 283,
     TOK_FLAG_CLOSEPAREN = 284,
     TOK_FLAG_SEP = 285,
     TOK_FLAG_ID = 286
   };
#endif
/* Tokens.  */
#define TOK_ID 258
#define TOK_SEP 259
#define TOK_OPEN 260
#define TOK_CLOSE 261
#define TOK_MODE 262
#define TOK_END_OF_RULE 263
#define TOK_EQUALS 264
#define TOK_ARROW 265
#define TOK_ADD_ASSIGN 266
#define TOK_SET_VAR 267
#define TOK_BOOL_VAR 268
#define TOK_VALUE 269
#define TOK_IF 270
#define TOK_ELSE 271
#define TOK_NOT 272
#define TOK_DEFINED 273
#define TOK_CHANGE_PROFILE 274
#define TOK_NETWORK 275
#define TOK_HAT 276
#define TOK_UNSAFE 277
#define TOK_COLON 278
#define TOK_LINK 279
#define TOK_OWNER 280
#define TOK_CAPABILITY 281
#define TOK_FLAGS 282
#define TOK_FLAG_OPENPAREN 283
#define TOK_FLAG_CLOSEPAREN 284
#define TOK_FLAG_SEP 285
#define TOK_FLAG_ID 286




/* Copy the first part of user declarations.  */
#line 1 "parser_yacc.y"

/* $Id: parser_yacc.y 1044 2007-12-20 12:55:27Z jrjohansen $ */

/*
 *   Copyright (c) 1999, 2000, 2001, 2002, 2003, 2004, 2005, 2006, 2007
 *   NOVELL (All rights reserved)
 *
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of version 2 of the GNU General Public
 *   License published by the Free Software Foundation.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, contact Novell, Inc.
 */

#define YYERROR_VERBOSE 1
#include <stdio.h>
#include <stdarg.h>
#include <string.h>
#include <stdlib.h>
#include <getopt.h>
#include <errno.h>
#include <fcntl.h>
#include <libintl.h>
#define _(s) gettext(s)

/* #define DEBUG */

#include "parser.h"
#include <unistd.h>
#include <netinet/in.h>
#include <sys/socket.h>
#include <arpa/inet.h>

#include <linux/capability.h>

#ifndef CAP_AUDIT_WRITE
#define CAP_AUDIT_WRITE 29
#endif
#ifndef CAP_AUDIT_CONTROL
#define CAP_AUDIT_CONTROL 30
#endif

/* A few utility defines */

#define CIDR_32 htonl(0xffffffff)
#define CIDR_24 htonl(0xffffff00)
#define CIDR_16 htonl(0xffff0000)
#define CIDR_8  htonl(0xff000000)

#define CAP_TO_MASK(x) (1 << (x))

static struct flagval force_complain_flags = {0, 1, 0};

/* from lex_config, for nice error messages */
/* extern char *current_file; */
extern int current_lineno;

struct value_list {
	char *value;
	struct value_list *next;
};

void free_value_list(struct value_list *list);
struct cod_entry *do_file_rule(char *namespace, char *id, int mode,
			       char *link_id);



/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif

#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
#line 109 "parser_yacc.y"
{
	char *id;
	char *flag_id;
	char *mode;
	struct aa_network_entry *network_entry;
	struct codomain *cod;
	struct cod_global_entry *entry;
	struct cod_net_entry *net_entry;
	struct cod_entry *user_entry;
	struct flagval flags;
	int fmode;
	unsigned int cap;
	unsigned int allowed_protocol;
	char *set_var;
	char *bool_var;
	char *var_val;
	struct value_list *val_list;
	int boolean;
}
/* Line 187 of yacc.c.  */
#line 252 "parser_yacc.c"
	YYSTYPE;
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
# define YYSTYPE_IS_TRIVIAL 1
#endif



/* Copy the second part of user declarations.  */


/* Line 216 of yacc.c.  */
#line 265 "parser_yacc.c"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(e) ((void) (e))
#else
# define YYUSE(e) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(n) (n)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int i)
#else
static int
YYID (i)
    int i;
#endif
{
  return i;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     ifndef _STDLIB_H
#      define _STDLIB_H 1
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined _STDLIB_H \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef _STDLIB_H
#    define _STDLIB_H 1
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss;
  YYSTYPE yyvs;
  };

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (YYID (0))
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  3
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   161

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  32
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  24
/* YYNRULES -- Number of rules.  */
#define YYNRULES  58
/* YYNRULES -- Number of states.  */
#define YYNSTATES  118

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   286

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint8 yyprhs[] =
{
       0,     0,     3,     6,     7,    10,    16,    24,    25,    28,
      32,    36,    40,    42,    45,    46,    52,    56,    60,    62,
      64,    65,    68,    72,    75,    78,    81,    84,    87,    93,
     103,   111,   114,   116,   119,   122,   124,   126,   130,   132,
     133,   136,   140,   144,   149,   153,   159,   166,   173,   176,
     180,   185,   187,   189,   191,   195,   201,   205,   208
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int8 yyrhs[] =
{
      33,     0,    -1,    36,    34,    -1,    -1,    34,    35,    -1,
       3,    39,     5,    42,     6,    -1,     3,    23,     3,    39,
       5,    42,     6,    -1,    -1,    36,    37,    -1,    12,     9,
      38,    -1,    12,    11,    38,    -1,    13,     9,    14,    -1,
      14,    -1,    38,    14,    -1,    -1,    27,     9,    28,    40,
      29,    -1,    28,    40,    29,    -1,    40,    30,    41,    -1,
      41,    -1,    31,    -1,    -1,    42,    48,    -1,    42,    25,
      46,    -1,    42,    50,    -1,    42,    53,    -1,    42,    54,
      -1,    42,    49,    -1,    42,    43,    -1,    15,    44,     5,
      42,     6,    -1,    15,    44,     5,    42,     6,    16,     5,
      42,     6,    -1,    15,    44,     5,    42,     6,    16,    43,
      -1,    17,    44,    -1,    13,    -1,    18,    12,    -1,    18,
      13,    -1,     3,    -1,    12,    -1,     5,    47,     6,    -1,
      48,    -1,    -1,    47,    48,    -1,    45,    52,     8,    -1,
      52,    45,     8,    -1,    22,    52,    45,     8,    -1,    45,
      52,    45,    -1,    24,     3,    10,     3,     8,    -1,    24,
      52,     3,    10,     3,     8,    -1,    51,     3,    39,     5,
      42,     6,    -1,    20,     8,    -1,    20,     3,     8,    -1,
      20,     3,     3,     8,    -1,     4,    -1,    21,    -1,     7,
      -1,    19,     3,     8,    -1,    19,     3,    23,     3,     8,
      -1,    26,    55,     8,    -1,    55,     3,    -1,     3,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   157,   157,   160,   162,   168,   192,   217,   219,   222,
     246,   271,   291,   303,   315,   321,   326,   331,   339,   344,
     360,   370,   380,   395,   421,   431,   437,   446,   452,   464,
     478,   492,   497,   512,   522,   532,   533,   535,   540,   549,
     551,   560,   565,   570,   579,   588,   599,   614,   632,   647,
     660,   671,   672,   674,   682,   693,   704,   709,   717
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "TOK_ID", "TOK_SEP", "TOK_OPEN",
  "TOK_CLOSE", "TOK_MODE", "TOK_END_OF_RULE", "TOK_EQUALS", "TOK_ARROW",
  "TOK_ADD_ASSIGN", "TOK_SET_VAR", "TOK_BOOL_VAR", "TOK_VALUE", "TOK_IF",
  "TOK_ELSE", "TOK_NOT", "TOK_DEFINED", "TOK_CHANGE_PROFILE",
  "TOK_NETWORK", "TOK_HAT", "TOK_UNSAFE", "TOK_COLON", "TOK_LINK",
  "TOK_OWNER", "TOK_CAPABILITY", "TOK_FLAGS", "TOK_FLAG_OPENPAREN",
  "TOK_FLAG_CLOSEPAREN", "TOK_FLAG_SEP", "TOK_FLAG_ID", "$accept", "list",
  "profilelist", "profile", "varlist", "varassign", "valuelist", "flags",
  "flagvals", "flagval", "rules", "cond_rule", "expr", "id_or_var",
  "owner_rule", "owner_rules", "rule", "hat", "network_rule", "hat_start",
  "file_mode", "change_profile", "capability", "caps", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    32,    33,    34,    34,    35,    35,    36,    36,    37,
      37,    37,    38,    38,    39,    39,    39,    40,    40,    41,
      42,    42,    42,    42,    42,    42,    42,    42,    43,    43,
      43,    44,    44,    44,    44,    45,    45,    46,    46,    47,
      47,    48,    48,    48,    48,    48,    48,    49,    50,    50,
      50,    51,    51,    52,    53,    53,    54,    55,    55
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     2,     0,     2,     5,     7,     0,     2,     3,
       3,     3,     1,     2,     0,     5,     3,     3,     1,     1,
       0,     2,     3,     2,     2,     2,     2,     2,     5,     9,
       7,     2,     1,     2,     2,     1,     1,     3,     1,     0,
       2,     3,     3,     4,     3,     5,     6,     6,     2,     3,
       4,     1,     1,     1,     3,     5,     3,     2,     1
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       7,     0,     3,     1,     0,     0,     2,     8,     0,     0,
       0,    14,     4,    12,     9,    10,    11,     0,     0,     0,
       0,    13,    14,     0,    19,     0,    18,    20,     0,     0,
      16,     0,     0,    20,     0,    17,    35,    51,     5,    53,
      36,     0,     0,     0,    52,     0,     0,     0,     0,    27,
       0,    21,    26,    23,     0,     0,    24,    25,     0,    15,
      32,     0,     0,     0,     0,     0,    48,     0,     0,     0,
      39,    22,    38,    58,     0,     0,    14,     0,     6,    31,
      33,    34,    20,    54,     0,     0,    49,     0,     0,     0,
       0,    57,    56,    41,    44,     0,    42,     0,     0,    50,
      43,     0,     0,    37,    40,    20,    28,    55,    45,     0,
       0,     0,    46,    47,    20,    30,     0,    29
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int8 yydefgoto[] =
{
      -1,     1,     6,    12,     2,     7,    14,    20,    25,    26,
      32,    49,    63,    50,    71,    90,    51,    52,    53,    54,
      55,    56,    57,    74
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -46
static const yytype_int16 yypact[] =
{
     -46,    27,    47,   -46,   105,    -1,    31,   -46,    26,    26,
      34,    40,   -46,   -46,    36,    36,   -46,    95,    84,    12,
     117,   -46,    48,    83,   -46,    90,   -46,   -46,   124,    12,
     -46,    12,     0,   -46,    94,   -46,   -46,   -46,   -46,   -46,
     -46,    74,   134,    63,   -46,   132,    39,     6,   137,   -46,
     132,   -46,   -46,   -46,   138,    29,   -46,   -46,    32,   -46,
     -46,    74,   123,   139,     8,    66,   -46,    29,   133,   142,
     -46,   -46,   -46,   -46,    87,     2,    48,   140,   -46,   -46,
     -46,   -46,   -46,   -46,   143,   141,   -46,   144,   147,   145,
      93,   -46,   -46,   -46,   -46,   146,   -46,    58,   148,   -46,
     -46,   149,   150,   -46,   -46,   -46,   126,   -46,   -46,   151,
      82,    18,   -46,   -46,   -46,   -46,   106,   -46
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
     -46,   -46,   -46,   -46,   -46,   -46,   152,   -21,   118,   127,
     -33,    43,    99,   -38,   -46,   -46,   -45,   -46,   -46,   -46,
      88,   -46,   -46,   -46
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -1
static const yytype_uint8 yytable[] =
{
      58,    28,    72,    36,    37,    36,    38,    39,    10,    36,
      93,    70,    40,    39,    40,    41,    83,    77,    40,    42,
      43,    44,    45,   114,    46,    47,    48,     3,    45,    87,
      46,    84,    36,    41,    11,    36,    37,    94,    78,    39,
      13,    40,    68,    24,    40,   104,    39,    41,    16,    97,
      21,    42,    43,    44,    45,    95,    46,    47,    48,     4,
       5,    36,    37,    17,   106,    39,    65,    18,    19,    85,
      40,    66,   110,    41,    86,    18,    19,    42,    43,    44,
      45,   116,    46,    47,    48,    36,    37,    60,   113,    39,
      91,    61,    62,    23,    40,    92,    36,    41,    22,   103,
      39,    42,    43,    44,    45,    40,    46,    47,    48,    36,
      37,    29,   117,    39,     8,    45,     9,    46,    40,    30,
      31,    41,    27,    59,    31,    42,    43,    44,    45,    33,
      46,    47,    48,    67,    69,    80,    81,    64,    75,    39,
      73,    76,   111,    88,    82,    89,    98,    34,    96,    99,
     101,   105,   100,   109,   115,   102,   107,   108,    35,   112,
      79,    15
};

static const yytype_uint8 yycheck[] =
{
      33,    22,    47,     3,     4,     3,     6,     7,     9,     3,
       8,     5,    12,     7,    12,    15,     8,    55,    12,    19,
      20,    21,    22,     5,    24,    25,    26,     0,    22,    67,
      24,    23,     3,    15,     3,     3,     4,    75,     6,     7,
      14,    12,     3,    31,    12,    90,     7,    15,    14,    82,
      14,    19,    20,    21,    22,    76,    24,    25,    26,    12,
      13,     3,     4,    23,     6,     7,     3,    27,    28,     3,
      12,     8,   105,    15,     8,    27,    28,    19,    20,    21,
      22,   114,    24,    25,    26,     3,     4,    13,     6,     7,
       3,    17,    18,     9,    12,     8,     3,    15,     3,     6,
       7,    19,    20,    21,    22,    12,    24,    25,    26,     3,
       4,    28,     6,     7,     9,    22,    11,    24,    12,    29,
      30,    15,     5,    29,    30,    19,    20,    21,    22,     5,
      24,    25,    26,    45,    46,    12,    13,     3,    50,     7,
       3,     3,    16,    10,     5,     3,     3,    29,     8,     8,
       3,     5,     8,     3,   111,    10,     8,     8,    31,     8,
      61,     9
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,    33,    36,     0,    12,    13,    34,    37,     9,    11,
       9,     3,    35,    14,    38,    38,    14,    23,    27,    28,
      39,    14,     3,     9,    31,    40,    41,     5,    39,    28,
      29,    30,    42,     5,    40,    41,     3,     4,     6,     7,
      12,    15,    19,    20,    21,    22,    24,    25,    26,    43,
      45,    48,    49,    50,    51,    52,    53,    54,    42,    29,
      13,    17,    18,    44,     3,     3,     8,    52,     3,    52,
       5,    46,    48,     3,    55,    52,     3,    45,     6,    44,
      12,    13,     5,     8,    23,     3,     8,    45,    10,     3,
      47,     3,     8,     8,    45,    39,     8,    42,     3,     8,
       8,     3,    10,     6,    48,     5,     6,     8,     8,     3,
      42,    16,     8,     6,     5,    43,    42,     6
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK (1);						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (YYID (N))                                                    \
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (YYID (0))
#endif


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if YYLTYPE_IS_TRIVIAL
#  define YY_LOCATION_PRINT(File, Loc)			\
     fprintf (File, "%d.%d-%d.%d",			\
	      (Loc).first_line, (Loc).first_column,	\
	      (Loc).last_line,  (Loc).last_column)
# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
	break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *bottom, yytype_int16 *top)
#else
static void
yy_stack_print (bottom, top)
    yytype_int16 *bottom;
    yytype_int16 *top;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; bottom <= top; ++bottom)
    YYFPRINTF (stderr, " %d", *bottom);
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yyrule)
    YYSTYPE *yyvsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      fprintf (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       		       );
      fprintf (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into YYRESULT an error message about the unexpected token
   YYCHAR while in state YYSTATE.  Return the number of bytes copied,
   including the terminating null byte.  If YYRESULT is null, do not
   copy anything; just return the number of bytes that would be
   copied.  As a special case, return 0 if an ordinary "syntax error"
   message will do.  Return YYSIZE_MAXIMUM if overflow occurs during
   size calculation.  */
static YYSIZE_T
yysyntax_error (char *yyresult, int yystate, int yychar)
{
  int yyn = yypact[yystate];

  if (! (YYPACT_NINF < yyn && yyn <= YYLAST))
    return 0;
  else
    {
      int yytype = YYTRANSLATE (yychar);
      YYSIZE_T yysize0 = yytnamerr (0, yytname[yytype]);
      YYSIZE_T yysize = yysize0;
      YYSIZE_T yysize1;
      int yysize_overflow = 0;
      enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
      char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
      int yyx;

# if 0
      /* This is so xgettext sees the translatable formats that are
	 constructed on the fly.  */
      YY_("syntax error, unexpected %s");
      YY_("syntax error, unexpected %s, expecting %s");
      YY_("syntax error, unexpected %s, expecting %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s");
# endif
      char *yyfmt;
      char const *yyf;
      static char const yyunexpected[] = "syntax error, unexpected %s";
      static char const yyexpecting[] = ", expecting %s";
      static char const yyor[] = " or %s";
      char yyformat[sizeof yyunexpected
		    + sizeof yyexpecting - 1
		    + ((YYERROR_VERBOSE_ARGS_MAXIMUM - 2)
		       * (sizeof yyor - 1))];
      char const *yyprefix = yyexpecting;

      /* Start YYX at -YYN if negative to avoid negative indexes in
	 YYCHECK.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;

      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yycount = 1;

      yyarg[0] = yytname[yytype];
      yyfmt = yystpcpy (yyformat, yyunexpected);

      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	  {
	    if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
	      {
		yycount = 1;
		yysize = yysize0;
		yyformat[sizeof yyunexpected - 1] = '\0';
		break;
	      }
	    yyarg[yycount++] = yytname[yyx];
	    yysize1 = yysize + yytnamerr (0, yytname[yyx]);
	    yysize_overflow |= (yysize1 < yysize);
	    yysize = yysize1;
	    yyfmt = yystpcpy (yyfmt, yyprefix);
	    yyprefix = yyor;
	  }

      yyf = YY_(yyformat);
      yysize1 = yysize + yystrlen (yyf);
      yysize_overflow |= (yysize1 < yysize);
      yysize = yysize1;

      if (yysize_overflow)
	return YYSIZE_MAXIMUM;

      if (yyresult)
	{
	  /* Avoid sprintf, as that infringes on the user's name space.
	     Don't have undefined behavior even if the translation
	     produced a string with the wrong number of "%s"s.  */
	  char *yyp = yyresult;
	  int yyi = 0;
	  while ((*yyp = *yyf) != '\0')
	    {
	      if (*yyp == '%' && yyf[1] == 's' && yyi < yycount)
		{
		  yyp += yytnamerr (yyp, yyarg[yyi++]);
		  yyf += 2;
		}
	      else
		{
		  yyp++;
		  yyf++;
		}
	    }
	}
      return yysize;
    }
}
#endif /* YYERROR_VERBOSE */


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yymsg, yytype, yyvaluep)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  YYUSE (yyvaluep);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
	break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */

#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */



/* The look-ahead symbol.  */
int yychar;

/* The semantic value of the look-ahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;



/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
  
  int yystate;
  int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Look-ahead token as an internal (translated) token number.  */
  int yytoken = 0;
#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack.  */
  yytype_int16 yyssa[YYINITDEPTH];
  yytype_int16 *yyss = yyssa;
  yytype_int16 *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  YYSTYPE *yyvsp;



#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  YYSIZE_T yystacksize = YYINITDEPTH;

  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;


  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;


	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),

		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);

#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;


      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     look-ahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to look-ahead token.  */
  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a look-ahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid look-ahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the look-ahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  yystate = yyn;
  *++yyvsp = yylval;

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
#line 158 "parser_yacc.y"
    { /* nothing */ ;}
    break;

  case 3:
#line 160 "parser_yacc.y"
    { /* nothing */ ;}
    break;

  case 4:
#line 163 "parser_yacc.y"
    {
		PDEBUG("Matched: list profile\n");
		add_to_list((yyvsp[(2) - (2)].cod));
	;}
    break;

  case 5:
#line 169 "parser_yacc.y"
    {
		struct codomain *cod = (yyvsp[(4) - (5)].cod);
		PDEBUG("Matched: id (%s) open rules close\n", (yyvsp[(1) - (5)].id));
		if (!cod) {
			yyerror(_("Memory allocation error."));
		}

		if ((yyvsp[(1) - (5)].id)[0] != '/')
			yyerror(_("Profile names must begin with a '/'."));

		cod->name = (yyvsp[(1) - (5)].id);
		cod->flags = (yyvsp[(2) - (5)].flags);
		if (force_complain)
			cod->flags = force_complain_flags;

		PDEBUG("%s: flags='%s%s'\n",
		       (yyvsp[(1) - (5)].id),
		       cod->flags.complain ? "complain, " : "",
		       cod->flags.audit ? "audit" : "");

		(yyval.cod) = cod;
	;}
    break;

  case 6:
#line 193 "parser_yacc.y"
    {
		struct codomain *cod = (yyvsp[(6) - (7)].cod);
		PDEBUG("Matched: id (%s:%s) open rules close\n", (yyvsp[(1) - (7)].id), (yyvsp[(3) - (7)].id));
		if (!cod) {
			yyerror(_("Memory allocation error."));
		}

		if ((yyvsp[(3) - (7)].id)[0] != '/')
			yyerror(_("Profile names must begin with a '/'."));

		cod->namespace = (yyvsp[(1) - (7)].id);
		cod->name = (yyvsp[(3) - (7)].id);
		cod->flags = (yyvsp[(4) - (7)].flags);
		if (force_complain)
			cod->flags = force_complain_flags;

		PDEBUG("%s: flags='%s%s'\n",
		       (yyvsp[(1) - (7)].id),
		       cod->flags.complain ? "complain, " : "",
		       cod->flags.audit ? "audit" : "");

		(yyval.cod) = cod;
	;}
    break;

  case 7:
#line 217 "parser_yacc.y"
    { /* nothing */ ;}
    break;

  case 8:
#line 220 "parser_yacc.y"
    { /* nothing */ ;}
    break;

  case 9:
#line 223 "parser_yacc.y"
    {
		struct value_list *list = (yyvsp[(3) - (3)].val_list);
		char *var_name = process_var((yyvsp[(1) - (3)].set_var));
		int err;
		if (!list || !list->value)
			yyerror("Assert: valuelist returned NULL");
		PDEBUG("Matched: set assignment for (%s)\n", (yyvsp[(1) - (3)].set_var));
		err = new_set_var(var_name, list->value);
		if (err) {
			yyerror("variable %s was previously declared", (yyvsp[(1) - (3)].set_var));
			/* FIXME: it'd be handy to report the previous location */
		}
		for (list = list->next; list; list = list->next) {
			err = add_set_value(var_name, list->value);
			if (err)
				yyerror("Error adding %s to set var %s",
					list->value, (yyvsp[(1) - (3)].set_var));
		}
		free_value_list((yyvsp[(3) - (3)].val_list));
		free(var_name);
		free((yyvsp[(1) - (3)].set_var));
	;}
    break;

  case 10:
#line 247 "parser_yacc.y"
    {
		struct value_list *list = (yyvsp[(3) - (3)].val_list);
		char *var_name = process_var((yyvsp[(1) - (3)].set_var));
		int err;
		if (!list || !list->value)
			yyerror("Assert: valuelist returned NULL");
		PDEBUG("Matched: additive assignment for (%s)\n", (yyvsp[(1) - (3)].set_var));
		/* do the first one outside the loop, subsequent
		 * failures are indicative of symtab failures */
		err = add_set_value(var_name, list->value);
		if (err) {
			yyerror("variable %s was not previously declared, but is being assigned additional values", (yyvsp[(1) - (3)].set_var));
		}
		for (list = list->next; list; list = list->next) {
			err = add_set_value(var_name, list->value);
			if (err)
				yyerror("Error adding %s to set var %s",
					list->value, (yyvsp[(1) - (3)].set_var));
		}
		free_value_list((yyvsp[(3) - (3)].val_list));
		free(var_name);
		free((yyvsp[(1) - (3)].set_var));
	;}
    break;

  case 11:
#line 272 "parser_yacc.y"
    {
		int boolean, err;
		char *var_name = process_var((yyvsp[(1) - (3)].bool_var));
		PDEBUG("Matched: boolean assignment (%s) to %s\n", (yyvsp[(1) - (3)].bool_var), (yyvsp[(3) - (3)].var_val));
		boolean = str_to_boolean((yyvsp[(3) - (3)].var_val));
		if (boolean == -1) {
			yyerror("Invalid boolean assignment for (%s): %s is not true or false",
				(yyvsp[(1) - (3)].bool_var), (yyvsp[(3) - (3)].var_val));
		}
		err = add_boolean_var(var_name, boolean);
		if (err) {
			yyerror("variable %s was previously declared", (yyvsp[(1) - (3)].bool_var));
			/* FIXME: it'd be handy to report the previous location */
		}
		free(var_name);
		free((yyvsp[(1) - (3)].bool_var));
		free((yyvsp[(3) - (3)].var_val));
	;}
    break;

  case 12:
#line 292 "parser_yacc.y"
    {
		struct value_list *new = malloc(sizeof(struct value_list));
		if (!new)
			yyerror(_("Memory allocation error."));
		PDEBUG("Matched: value (%s)\n", (yyvsp[(1) - (1)].var_val));

		new->value = (yyvsp[(1) - (1)].var_val);
		new->next = NULL;
		(yyval.val_list) = new;
	;}
    break;

  case 13:
#line 304 "parser_yacc.y"
    {
		struct value_list *new = malloc(sizeof(struct value_list));
		if (!new)
			yyerror(_("Memory allocation error."));
		PDEBUG("Matched: value (%s)\n", (yyvsp[(1) - (2)].val_list));

		new->value = (yyvsp[(2) - (2)].var_val);
		new->next = (yyvsp[(1) - (2)].val_list);
		(yyval.val_list) = new;
	;}
    break;

  case 14:
#line 315 "parser_yacc.y"
    { /* nothing */
		struct flagval fv = { 0, 0, 0 };

		(yyval.flags) = fv;
	;}
    break;

  case 15:
#line 322 "parser_yacc.y"
    {
		(yyval.flags) = (yyvsp[(4) - (5)].flags);
	;}
    break;

  case 16:
#line 327 "parser_yacc.y"
    {
		(yyval.flags) = (yyvsp[(2) - (3)].flags);
	;}
    break;

  case 17:
#line 332 "parser_yacc.y"
    {
		(yyvsp[(1) - (3)].flags).complain = (yyvsp[(1) - (3)].flags).complain || (yyvsp[(3) - (3)].flags).complain;
		(yyvsp[(1) - (3)].flags).audit = (yyvsp[(1) - (3)].flags).audit || (yyvsp[(3) - (3)].flags).audit;

		(yyval.flags) = (yyvsp[(1) - (3)].flags);
	;}
    break;

  case 18:
#line 340 "parser_yacc.y"
    {
		(yyval.flags) = (yyvsp[(1) - (1)].flags);
	;}
    break;

  case 19:
#line 345 "parser_yacc.y"
    {
		struct flagval fv = {0, 0, 0};
		if (strcmp((yyvsp[(1) - (1)].flag_id), "debug") == 0) {
			yyerror(_("Profile flag 'debug' is no longer valid."));
		} else if (strcmp((yyvsp[(1) - (1)].flag_id), "complain") == 0) {
			fv.complain = 1;
		} else if (strcmp((yyvsp[(1) - (1)].flag_id), "audit") == 0) {
			fv.audit = 1;
		} else {
			yyerror(_("Invalid profile flag: %s."), (yyvsp[(1) - (1)].flag_id));
		}
		free((yyvsp[(1) - (1)].flag_id));
		(yyval.flags) = fv;
	;}
    break;

  case 20:
#line 360 "parser_yacc.y"
    { /* nothing */ 
		struct codomain *cod = NULL;
		cod = (struct codomain *) calloc(1, sizeof(struct codomain));
		if (!cod) {
			yyerror(_("Memory allocation error."));
		}

		(yyval.cod) = cod;
	;}
    break;

  case 21:
#line 371 "parser_yacc.y"
    {
		PDEBUG("matched: rules rule\n");
		PDEBUG("rules rule: (%s)\n", (yyvsp[(2) - (2)].user_entry)->name);
		if (!(yyvsp[(2) - (2)].user_entry))
			yyerror(_("Assert: `rule' returned NULL."));
		add_entry_to_policy((yyvsp[(1) - (2)].cod), (yyvsp[(2) - (2)].user_entry));
		(yyval.cod) = (yyvsp[(1) - (2)].cod);
	;}
    break;

  case 22:
#line 381 "parser_yacc.y"
    {
		struct cod_entry *entry, *tmp;

		PDEBUG("matched: rules owner_rules\n");
		PDEBUG("rules owner_rules: (%s)\n", (yyvsp[(3) - (3)].user_entry)->name);
		if ((yyvsp[(3) - (3)].user_entry)) {
			list_for_each_safe((yyvsp[(3) - (3)].user_entry), entry, tmp) {
				entry->next = NULL;
				add_entry_to_policy((yyvsp[(1) - (3)].cod), entry);
			}
		}
		(yyval.cod) = (yyvsp[(1) - (3)].cod);
	;}
    break;

  case 23:
#line 396 "parser_yacc.y"
    {
		struct aa_network_entry *entry, *tmp;

		PDEBUG("Matched: network rule\n");
		if (!(yyvsp[(2) - (2)].network_entry))
			yyerror(_("Assert: `network_rule' return invalid protocol."));
		if (!(yyvsp[(1) - (2)].cod)->network_allowed) {
			(yyvsp[(1) - (2)].cod)->network_allowed = calloc(AF_MAX,
						     sizeof(unsigned int));
			if (!(yyvsp[(1) - (2)].cod)->network_allowed)
				yyerror(_("Memory allocation error."));
		}
		list_for_each_safe((yyvsp[(2) - (2)].network_entry), entry, tmp) {
			if (entry->type > SOCK_PACKET) {
				/* setting mask instead of a bit */
				(yyvsp[(1) - (2)].cod)->network_allowed[entry->family] |= entry->type;
			} else {
				(yyvsp[(1) - (2)].cod)->network_allowed[entry->family] |= 1 << entry->type;
			}
			free(entry);
		}

		(yyval.cod) = (yyvsp[(1) - (2)].cod)
	;}
    break;

  case 24:
#line 422 "parser_yacc.y"
    {
		PDEBUG("matched: rules change_profile\n");
		PDEBUG("rules change_profile: (%s)\n", (yyvsp[(2) - (2)].user_entry)->name);
		if (!(yyvsp[(2) - (2)].user_entry))
			yyerror(_("Assert: `change_profile' returned NULL."));
		add_entry_to_policy((yyvsp[(1) - (2)].cod), (yyvsp[(2) - (2)].user_entry));
		(yyval.cod) = (yyvsp[(1) - (2)].cod);
	;}
    break;

  case 25:
#line 432 "parser_yacc.y"
    {
		(yyvsp[(1) - (2)].cod)->capabilities = (yyvsp[(1) - (2)].cod)->capabilities | (yyvsp[(2) - (2)].cap);
		(yyval.cod) = (yyvsp[(1) - (2)].cod);
	;}
    break;

  case 26:
#line 438 "parser_yacc.y"
    {
		PDEBUG("Matched: hat rule\n");
		if (!(yyvsp[(2) - (2)].cod))
			yyerror(_("Assert: 'hat rule' returned NULL."));
		add_hat_to_policy((yyvsp[(1) - (2)].cod), (yyvsp[(2) - (2)].cod));
		(yyval.cod) = (yyvsp[(1) - (2)].cod);
	;}
    break;

  case 27:
#line 447 "parser_yacc.y"
    {
		PDEBUG("Matched: conditional rules\n");
		(yyval.cod) = merge_policy((yyvsp[(1) - (2)].cod), (yyvsp[(2) - (2)].cod));
	;}
    break;

  case 28:
#line 453 "parser_yacc.y"
    {
		struct codomain *ret = NULL;
		PDEBUG("Matched: found conditional rules\n");
		if ((yyvsp[(2) - (5)].boolean)) {
			ret = (yyvsp[(4) - (5)].cod);
		} else {
			free_policy((yyvsp[(4) - (5)].cod));
		}
		(yyval.cod) = ret;
	;}
    break;

  case 29:
#line 465 "parser_yacc.y"
    {
		struct codomain *ret = NULL;
		PDEBUG("Matched: found conditional else rules\n");
		if ((yyvsp[(2) - (9)].boolean)) {
			ret = (yyvsp[(4) - (9)].cod);
			free_policy((yyvsp[(8) - (9)].cod));
		} else {
			ret = (yyvsp[(8) - (9)].cod);
			free_policy((yyvsp[(4) - (9)].cod));
		}
		(yyval.cod) = ret;
	;}
    break;

  case 30:
#line 479 "parser_yacc.y"
    {
		struct codomain *ret = NULL;
		PDEBUG("Matched: found conditional else-if rules\n");
		if ((yyvsp[(2) - (7)].boolean)) {
			ret = (yyvsp[(4) - (7)].cod);
			free_policy((yyvsp[(7) - (7)].cod));
		} else {
			ret = (yyvsp[(7) - (7)].cod);
			free_policy((yyvsp[(4) - (7)].cod));
		}
		(yyval.cod) = ret;
	;}
    break;

  case 31:
#line 493 "parser_yacc.y"
    {
		(yyval.boolean) = !(yyvsp[(2) - (2)].boolean);
	;}
    break;

  case 32:
#line 498 "parser_yacc.y"
    {
		char *var_name = process_var((yyvsp[(1) - (1)].bool_var));
		int boolean  = get_boolean_var(var_name);
		PDEBUG("Matched: boolean expr %s value: %d\n", (yyvsp[(1) - (1)].bool_var), boolean);
		if (boolean < 0) {
			/* FIXME check for set var */
			yyerror(_("Unset boolean variable %s used in if-expression"),
				(yyvsp[(1) - (1)].bool_var));
		}
		(yyval.boolean) = boolean;
		free(var_name);
		free((yyvsp[(1) - (1)].bool_var));
	;}
    break;

  case 33:
#line 513 "parser_yacc.y"
    {
		char *var_name = process_var((yyvsp[(2) - (2)].set_var));
		void *set_value = get_set_var(var_name);
		PDEBUG("Matched: defined set expr %s value %lx\n", (yyvsp[(2) - (2)].set_var), (long) set_value);
		(yyval.boolean) = !! (long) set_value;
		free(var_name);
		free((yyvsp[(2) - (2)].set_var));
	;}
    break;

  case 34:
#line 523 "parser_yacc.y"
    {
		char *var_name = process_var((yyvsp[(2) - (2)].bool_var));
		int boolean = get_boolean_var(var_name);
		PDEBUG("Matched: defined set expr %s value %d\n", (yyvsp[(2) - (2)].bool_var), boolean);
		(yyval.boolean) = (boolean != -1);
		free(var_name);
		free((yyvsp[(2) - (2)].bool_var));
	;}
    break;

  case 35:
#line 532 "parser_yacc.y"
    { (yyval.id) = (yyvsp[(1) - (1)].id); ;}
    break;

  case 36:
#line 533 "parser_yacc.y"
    { (yyval.id) = (yyvsp[(1) - (1)].set_var); ;}
    break;

  case 37:
#line 536 "parser_yacc.y"
    {
		(yyval.user_entry) = (yyvsp[(2) - (3)].user_entry);
	;}
    break;

  case 38:
#line 541 "parser_yacc.y"
    {
		/* mask mode to owner permissions */
		if ((yyvsp[(1) - (1)].user_entry)) {
			(yyvsp[(1) - (1)].user_entry)->mode &= (AA_USER_PERMS | AA_SHARED_PERMS);
		}
		(yyval.user_entry) = (yyvsp[(1) - (1)].user_entry);
	;}
    break;

  case 39:
#line 549 "parser_yacc.y"
    { (yyval.user_entry) = NULL; ;}
    break;

  case 40:
#line 552 "parser_yacc.y"
    {
		if ((yyvsp[(2) - (2)].user_entry)) {
			(yyvsp[(2) - (2)].user_entry)->mode &= (AA_USER_PERMS | AA_SHARED_PERMS);
			(yyvsp[(2) - (2)].user_entry)->next = (yyvsp[(1) - (2)].user_entry);
		}
		(yyval.user_entry) = (yyvsp[(2) - (2)].user_entry);
	;}
    break;

  case 41:
#line 561 "parser_yacc.y"
    {
		(yyval.user_entry) = do_file_rule(NULL, (yyvsp[(1) - (3)].id), (yyvsp[(2) - (3)].fmode), NULL);
	;}
    break;

  case 42:
#line 566 "parser_yacc.y"
    {
		(yyval.user_entry) = do_file_rule(NULL, (yyvsp[(2) - (3)].id), (yyvsp[(1) - (3)].fmode) & ~ALL_AA_EXEC_UNSAFE, NULL);
 	;}
    break;

  case 43:
#line 571 "parser_yacc.y"
    {
		int mode = (((yyvsp[(2) - (4)].fmode) & AA_EXEC_BITS) << 7) & ALL_AA_EXEC_UNSAFE;
		if (!((yyvsp[(2) - (4)].fmode) & AA_EXEC_BITS))
			yyerror(_("unsafe rule missing exec permissions"));
		(yyval.user_entry) = do_file_rule(NULL, (yyvsp[(3) - (4)].id), ((yyvsp[(2) - (4)].fmode) & ~ALL_AA_EXEC_UNSAFE) | mode,
				  NULL);
	;}
    break;

  case 44:
#line 580 "parser_yacc.y"
    {
		/* Oopsie, we appear to be missing an EOL marker. If we
		 * were *smart*, we could work around it. Since we're
		 * obviously not smart, we'll just punt with a more
		 * sensible error. */
		yyerror(_("missing an end of line character? (entry: %s)"), (yyvsp[(1) - (3)].id));
	;}
    break;

  case 45:
#line 589 "parser_yacc.y"
    {
		struct cod_entry *entry;
		PDEBUG("Matched: link tok_id (%s) -> (%s)\n", (yyvsp[(2) - (5)].id), (yyvsp[(4) - (5)].id));
		entry = new_entry(NULL, (yyvsp[(2) - (5)].id), AA_LINK_BITS, (yyvsp[(4) - (5)].id));
		if (!entry)
			yyerror(_("Memory allocation error."));
		PDEBUG("rule.entry: link (%s)\n", entry->name);
		(yyval.user_entry) = entry;
	;}
    break;

  case 46:
#line 600 "parser_yacc.y"
    {
		struct cod_entry *entry;
		PDEBUG("Matched: link tok_id (%s) -> (%s)\n", (yyvsp[(3) - (6)].id), (yyvsp[(5) - (6)].id));
		if ((yyvsp[(2) - (6)].fmode) & ~AA_LINK_BITS) {
			yyerror(_("only link perms can be specified in a link rule."));
		} else {
			entry = new_entry(NULL, (yyvsp[(3) - (6)].id), (yyvsp[(2) - (6)].fmode), (yyvsp[(5) - (6)].id));
			if (!entry)
				yyerror(_("Memory allocation error."));
		}
		PDEBUG("rule.entry: link (%s)\n", entry->name);
		(yyval.user_entry) = entry;
	;}
    break;

  case 47:
#line 615 "parser_yacc.y"
    {
		struct codomain *cod = (yyvsp[(5) - (6)].cod);
		PDEBUG("Matched: sep id (%s) open rules close\n", (yyvsp[(2) - (6)].id));
		if (!cod) {
			yyerror(_("Memory allocation error."));
		}
		cod->name = (yyvsp[(2) - (6)].id);
		cod->flags = (yyvsp[(3) - (6)].flags);
		if (force_complain)
			cod->flags = force_complain_flags;
		PDEBUG("^%s: flags='%s%s'\n",
		       (yyvsp[(2) - (6)].id),
		       cod->flags.complain ? "complain, " : "",
		       cod->flags.audit ? "audit" : "");
		(yyval.cod) = cod;
	;}
    break;

  case 48:
#line 633 "parser_yacc.y"
    {
		int family;
		struct aa_network_entry *new_entry, *entry = NULL;
		for (family = AF_UNSPEC; family < AF_MAX; family++) {
			new_entry = new_network_ent(family, 0xffffffff,
						    0xffffffff);
			if (!new_entry)
				yyerror(_("Memory allocation error."));
			new_entry->next = entry;
			entry = new_entry;
		}
		(yyval.network_entry) = entry;
	;}
    break;

  case 49:
#line 648 "parser_yacc.y"
    {
		struct aa_network_entry *entry;
		entry = network_entry((yyvsp[(2) - (3)].id), NULL, NULL);
		if (!entry)
			/* test for short circuiting of family */
			entry = network_entry(NULL, (yyvsp[(2) - (3)].id), NULL);
		if (!entry)
			yyerror(_("Invalid network entry."));
		free((yyvsp[(2) - (3)].id));
		(yyval.network_entry) = entry;
	;}
    break;

  case 50:
#line 661 "parser_yacc.y"
    {
		struct aa_network_entry *entry;
		entry = network_entry((yyvsp[(2) - (4)].id), (yyvsp[(3) - (4)].id), NULL);
		if (!entry)
			yyerror(_("Invalid network entry."));
		free((yyvsp[(2) - (4)].id));
		free((yyvsp[(3) - (4)].id));
		(yyval.network_entry) = entry;
	;}
    break;

  case 51:
#line 671 "parser_yacc.y"
    {;}
    break;

  case 52:
#line 672 "parser_yacc.y"
    {;}
    break;

  case 53:
#line 675 "parser_yacc.y"
    {
		/* A single TOK_MODE maps to the same permission in all
		 * of user:group:other */
		(yyval.fmode) = parse_mode((yyvsp[(1) - (1)].mode));
		free((yyvsp[(1) - (1)].mode));
	;}
    break;

  case 54:
#line 683 "parser_yacc.y"
    {
		struct cod_entry *entry;
		PDEBUG("Matched change_profile: tok_id (%s)\n", (yyvsp[(2) - (3)].id));
		entry = new_entry(NULL, (yyvsp[(2) - (3)].id), AA_CHANGE_PROFILE, NULL);
		if (!entry)
			yyerror(_("Memory allocation error."));
		PDEBUG("change_profile.entry: (%s)\n", entry->name);
		(yyval.user_entry) = entry;
	;}
    break;

  case 55:
#line 694 "parser_yacc.y"
    {
		struct cod_entry *entry;
		PDEBUG("Matched change_profile: tok_id (%s:%s)\n", (yyvsp[(2) - (5)].id), (yyvsp[(4) - (5)].id));
		entry = new_entry((yyvsp[(2) - (5)].id), (yyvsp[(4) - (5)].id), AA_CHANGE_PROFILE, NULL);
		if (!entry)
			yyerror(_("Memory allocation error."));
		PDEBUG("change_profile.entry: (%s)\n", entry->name);
		(yyval.user_entry) = entry;
	;}
    break;

  case 56:
#line 705 "parser_yacc.y"
    {
		(yyval.cap) = (yyvsp[(2) - (3)].cap);		
	;}
    break;

  case 57:
#line 710 "parser_yacc.y"
    {
		int cap = name_to_capability((yyvsp[(2) - (2)].id));
		if (cap == -1)
			yyerror(_("Invalid capability %s."), (yyvsp[(2) - (2)].id));
		(yyval.cap) = (yyvsp[(1) - (2)].cap) | CAP_TO_MASK(cap);
	;}
    break;

  case 58:
#line 718 "parser_yacc.y"
    {
		int cap = name_to_capability((yyvsp[(1) - (1)].id));
		if (cap == -1)
			yyerror(_("Invalid capability %s."), (yyvsp[(1) - (1)].id));
		(yyval.cap) = CAP_TO_MASK(cap);
	;}
    break;


/* Line 1267 of yacc.c.  */
#line 2261 "parser_yacc.c"
      default: break;
    }
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;


  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
      {
	YYSIZE_T yysize = yysyntax_error (0, yystate, yychar);
	if (yymsg_alloc < yysize && yymsg_alloc < YYSTACK_ALLOC_MAXIMUM)
	  {
	    YYSIZE_T yyalloc = 2 * yysize;
	    if (! (yysize <= yyalloc && yyalloc <= YYSTACK_ALLOC_MAXIMUM))
	      yyalloc = YYSTACK_ALLOC_MAXIMUM;
	    if (yymsg != yymsgbuf)
	      YYSTACK_FREE (yymsg);
	    yymsg = (char *) YYSTACK_ALLOC (yyalloc);
	    if (yymsg)
	      yymsg_alloc = yyalloc;
	    else
	      {
		yymsg = yymsgbuf;
		yymsg_alloc = sizeof yymsgbuf;
	      }
	  }

	if (0 < yysize && yysize <= yymsg_alloc)
	  {
	    (void) yysyntax_error (yymsg, yystate, yychar);
	    yyerror (yymsg);
	  }
	else
	  {
	    yyerror (YY_("syntax error"));
	    if (yysize != 0)
	      goto yyexhaustedlab;
	  }
      }
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse look-ahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse look-ahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  *++yyvsp = yylval;


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#ifndef yyoverflow
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEOF && yychar != YYEMPTY)
     yydestruct ("Cleanup: discarding lookahead",
		 yytoken, &yylval);
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}


#line 725 "parser_yacc.y"

#define MAXBUFSIZE 4096

void yyerror(char *msg, ...)
{
	va_list arg;
	char buf[MAXBUFSIZE];

	va_start(arg, msg);
	vsnprintf(buf, sizeof(buf), msg, arg);
	va_end(arg);

	if (profilename) {
		PERROR(_("AppArmor parser error in %s at line %d: %s\n"),
		       profilename, current_lineno, buf);
	} else {
		PERROR(_("AppArmor parser error, line %d: %s\n"),
		       current_lineno, buf);
	}

	exit(1);
}

void free_value_list(struct value_list *list)
{
	struct value_list *next;

	while (list) {
		next = list->next;
		if (list->value)
			free(list->value);
		free(list);
		list = next;
	}
}

struct cod_entry *do_file_rule(char *namespace, char *id, int mode,
			       char *link_id)
{
		struct cod_entry *entry;
		PDEBUG("Matched: tok_id (%s) tok_mode (0x%x)\n", id, mode);
		entry = new_entry(namespace, id, mode, link_id);
		if (!entry)
			yyerror(_("Memory allocation error."));
		PDEBUG("rule.entry: (%s)\n", entry->name);
		return entry;
}

